/*----------------------------------------------------------------
 * comix.h - header pro game.c
 *----------------------------------------------------------------
 */

#ifndef COMIX_H_INCLUDED
#define COMIX_H_INCLUDED


#include <allegro.h>

#define MAX_COMIX_IMAGE 20
#define MAX_VIRTUAL_IMAGE 20
#define MAX_COMIX_SOUND 20


/*

  bitmapa je bitmapa, virtualni bitmapa je bitmapa
  ukazujici na cast (popr. celou) bitmapu, se kterou se
  nadale pak pracuje a delaji se na ni (s ni) efekty.

  U virtualni bitmapy uvadime:
  IMAGE
  X
  Y
  WIDTH
  HEIGHT

  Efekty:
  EFFECT
  TYPE=VALUE1
  TEMPO=VALUE2

*/


extern BITMAP *c_image[MAX_COMIX_IMAGE];

typedef struct {
    int image;
    int pos_X, pos_Y;
    int X;
    int Y;
    int new_X, new_Y;
    int visible;
    int width;
    int height;
    int effect;
    int param1;
    int param2;
    int type;
    int tempo;
	int fade, fade_value;	// pruhlednost
	int re_width, re_height, r_w, r_h;	// zvetseni ci zmensen bitmapy
    long old;
    int anim_count, anim_actual;
    int anim_x, anim_y;
    int anim_tempo, anim_tempo_old;
    int anim_type, anim_pingpong;
} VIRTUAL_IMAGE_TYPE;

extern VIRTUAL_IMAGE_TYPE v_image[MAX_VIRTUAL_IMAGE];
extern SAMPLE *c_sound[MAX_COMIX_SOUND];




int comix_play(char *name);
int comix_play_file(char *name);





#endif //comix_H_INCLUDED

