/*----------------------------------------------------------------
 * init.c - nacitani souboru a pod.
 *----------------------------------------------------------------
 */

#include <stdio.h>
#include <stdarg.h>
#include <allegro.h>
#include <string.h>
#include "criterr.h"       /* prototype for `critical_error' */
#include "variable.h"
#include "animator.h"
#include "sound.h"





int load_object(char *name, int index)
{
  char filename[40];
  char s[40];
  char gfxfile[40];
  FILE *file;
  int i, n;

  strcpy(filename, OBJECT_DIR);

#ifdef DEBUG_VERSION
    fprintf(debugfile,"OBJECT\nFILENAME: %s\n", filename);
#endif

  strcat(filename, name);
  file = fopen(filename, "r");
  if( !file ) {
    critical_error ("Unable to open file %s", filename);
  }

	object[index].show_count = 0;

	fscanf(file, "ANIMATION %s\n", s);
	object[index].anim_object = load_anim_object(s);


	fscanf(file, "TYPE %d\n", &object[index].type);
	fscanf(file, "DELAY %d\n", &object[index].delay);
object[index].delay += 4-obtiznost*2;
	fscanf(file, "MAX_SHOW %d\n", &object[index].max_show);
	fscanf(file, "SCORE %d\n", &object[index].score);

    fscanf(file, "SOUND_DEAD %s\n", s);
    strcpy(gfxfile, SOUND_DIR);
    strcat(gfxfile, s);
	object[index].s_dead = load_sample(gfxfile);
    fscanf(file, "SOUND_SHOT %s\n", s);
    strcpy(gfxfile, SOUND_DIR);
    strcat(gfxfile, s);
	object[index].s_shot = load_sample(gfxfile);
    fscanf(file, "SOUND_CRY %s\n", s);
    strcpy(gfxfile, SOUND_DIR);
    strcat(gfxfile, s);
	object[index].s_cry = load_sample(gfxfile);

    fscanf(file, "CHILD %d\n", &object[index].next_name);

	fscanf(file, "TICKS %d\n", &object[index].end_tick);
	for (i=0; i<object[index].end_tick; i++)
	{
		//FIXME: no mozna cist ticky, ale nemusi se
		fscanf(file, "%d %d\n", &n, &object[index].tick[i]);
#ifdef DEBUG_VERSION
    fprintf(debugfile,"EXX %d %d\n", i, object[index].tick[i]);
#endif


	}


#ifdef DEBUG_VERSION
    fprintf(debugfile,"OBJECT OK\n");
#endif


	fclose(file);
	return 0;
}


int destroy_object(int index)
{
	destroy_anim_object(object[index].anim_object);
	destroy_sample(object[index].s_dead);
	destroy_sample(object[index].s_shot);
	destroy_sample(object[index].s_cry);
	return 0;
}





int load_decoration(char *name, int index)
{
  char filename[40];
  char s[40];
  char gfxfile[40];
  FILE *file;


  strcpy(filename, DECORATION_DIR);

#ifdef DEBUG_VERSION
    fprintf(debugfile,"DECORATION\nFILENAME: %s\n", filename);
#endif

  strcat(filename, name);
  file = fopen(filename, "r");
  if( !file ) {
    critical_error ("Unable to open file %s", filename);
  }

	decoration[index].mode = 0;
	decoration[index].old_time = 0;

	fscanf(file, "ANIMATION %s\n", s);
	decoration[index].anim_object = load_anim_object(s);


	fscanf(file, "TYPE %d\n", &decoration[index].type);
	fscanf(file, "X %d\n", &decoration[index].X);
	fscanf(file, "Y %d\n", &decoration[index].Y);

	fscanf(file, "S_NORMAL %s\n", s);
	if (strcmp(s, "NULL")==0)
		decoration[index].s_normal = NULL;
	else
	{
		strcpy(gfxfile, SOUND_DIR);
		strcat(gfxfile, s);
		decoration[index].s_normal = load_sample(gfxfile);
	}
	fscanf(file, "S_DESTROY %s\n", s);
	if (strcmp(s, "NULL")==0)
		decoration[index].s_destroy = NULL;
	else
	{
		strcpy(gfxfile, SOUND_DIR);
		strcat(gfxfile, s);
		decoration[index].s_destroy = load_sample(gfxfile);
	}


#ifdef DEBUG_VERSION
    fprintf(debugfile,"DECORATION OK\n");
#endif

	fclose(file);
	return 0;
}


int destroy_decoration(int index)
{
	destroy_anim_object(decoration[index].anim_object);
	if (decoration[index].s_destroy != NULL)
		destroy_sample(decoration[index].s_destroy);
	if (decoration[index].s_normal != NULL)
		destroy_sample(decoration[index].s_normal);
	return 0;
}





int init_small(int door, int index)
{
	small_object[door].draw = 1;
	small_object[door].mode = 0;
	small_object[door].type = object[index].type;
	small_object[door].animation = index;
	small_object[door].delay = object[index].delay;
	small_object[door].position = 0; // ?? na co je ?
	small_object[door].tik = 0;
	//small_object[door].shot_tick = object[index].shot_tick;
	//small_object[door].dead_tick = object[index].dead_tick;
	small_object[door].end_tick = object[index].end_tick;
	small_object[door].last_time = 0;
	small_object[door].Y = 107;
	if (door == 0)
	{
		small_object[door].X = 96;
	}
	if (door == 1)
	{
		small_object[door].X = 317;
	}
	if (door == 2)
	{
		small_object[door].X = 539;
	}

	return 0;
}








int load_level(char *name, int index)
{
  char filename[40];
  char s[40];
  char gfxfile[40];
  FILE *file;
  int i;
  int tmp = 0;

  strcpy(filename, LEVEL_DIR);
#ifdef DEBUG_VERSION
    fprintf(debugfile,"LEVEL\nFILENAME: %s\n", filename);
#endif

  strcat(filename, name);
  file = fopen(filename, "r");
  if( !file ) {
    critical_error ("Unable to open file %s", filename);
  }



    object_count = 0;
	small_object[0].draw = 0;
	small_object[1].draw = 0;
	small_object[2].draw = 0;
	level_time = 0;
	max_level_bandit = 20;
	pocet_zabitych = 0;
	level = 0;
	refresh_door = 100;
	next_level = 1;
	decoration_count = 0;
	max_pravdepodobnost = 0;
	strcpy(komix_start,"");
	strcpy(komix_finish, "");
	celkem_naboju = 10000;
	pocet_naboju = 6;

	fscanf(file, "%s", s);

	// cyklus najede na zacatek levelu
	while (level != index)
	{
		if (strcmp(s,"LEVEL")==0)
		{
			fscanf(file, " %d\n", &i);
			if (i==index)
				level = i;
		} else {
			if (strcmp(s,"CREATURE")==0)
				fscanf(file, " %s %d\n", s, &i);
			else
				fscanf(file, " %s\n", s);
		}
	fscanf(file, "%s", s);
	}

	// cte soubor levelu
	while ((strcmp(s, "END_OF_LEVEL") != 0) && (level == index))
	{
		if (level==index)
		{
			if (strcmp(s,"CREATURE")==0)
			{
				fscanf(file, " %s %d\n", s, &tmp);
				load_object(s, object_count);
				max_pravdepodobnost += tmp;
				//vaha += tmp;
				object[object_count].vaha = max_pravdepodobnost;
				object_count++;
			}
			if (strcmp(s,"DECORATION")==0)
			{
				fscanf(file, " %s\n", s);
				load_decoration(s, decoration_count);
				decoration_count++;
			}
			if (strcmp(s,"KOMIX_START")==0)
			{
				fscanf(file, " %s\n", s);
				strcpy(komix_start, s);
			}
			if (strcmp(s,"KOMIX_FINISH")==0)
			{
				fscanf(file, " %s\n", s);
				strcpy(komix_finish, s);
			}
			if (strcmp(s,"NEXT")==0)
			{
				fscanf(file, " %d\n", &next_level);
			}
			if (strcmp(s,"BACK")==0)
			{
				fscanf(file, " %s\n", s);
				strcpy(gfxfile, GFX_DIR);
			    strcat(gfxfile, s);
				if (vrstva[0].image != NULL)
					destroy_bitmap(vrstva[0].image);
				vrstva[0].image = load_bitmap(gfxfile, pal);
				vrstva[0].X = 0;
			    vrstva[0].Y = 0;
				vrstva[0].width = 640;
			    vrstva[0].height = 480;
			}
			if (strcmp(s,"MAX_DOORS_OPEN")==0)
			{
				fscanf(file, " %d\n", &max_doors_open);
			}
			if (strcmp(s,"REFRESH_DOOR")==0)
			{
				fscanf(file, " %d\n", &refresh_door);
			}
			if (strcmp(s,"MODE")==0)
			{
				fscanf(file, " %d\n", &level_mode);
			}
			if (strcmp(s,"TIME")==0)
			{
				fscanf(file, " %d\n", &level_time);
			}
			if (strcmp(s,"MAX_BANDIT")==0)
			{
				fscanf(file, " %d\n", &max_level_bandit);
			}
			if (strcmp(s,"BULLETS")==0)
			{
				fscanf(file, " %d\n", &pocet_naboju);
			}
			if (strcmp(s,"AMMO")==0)
			{
				fscanf(file, " %d\n", &celkem_naboju);
			}
			if (strcmp(s,"ADD_LIFE")==0)
			{
				fscanf(file, " %d\n", &i);
				pocet_zivotu += i;
				if (pocet_zivotu>10)
					pocet_zivotu = 10;

			}




		}
		fscanf(file, "%s", s);
	}

	set_mouse_sprite(mouse_shot);


#ifdef TO_VIDEO
    acquire_bitmap(game_screen2);
#endif
    blit(vrstva[0].image, game_screen2, 0, 0, vrstva[0].X, vrstva[0].Y,
 vrstva[0].width, vrstva[0].height);
#ifdef TO_VIDEO
    release_bitmap(game_screen2);
#endif



#ifdef DEBUG_VERSION
    fprintf(debugfile,"LEVEL OK\n");
#endif
	fclose(file);

	shot_last_time = 0;
	shot_show = 0;
	reload_show = 0;

	for (i=0; i<MAX_POCET_DER; i++)
		dira[i].visible = 0;

	return 0;
}




int destroy_level()
{
	int i;

	for (i=0; i<object_count; i++)
	{
		destroy_object(i);
	}
	object_count = 0;
	for (i=0; i<decoration_count; i++)
	{
		destroy_decoration(i);
	}
	decoration_count = 0;
	if (vrstva[0].image != NULL)
	{
		destroy_bitmap(vrstva[0].image);
		vrstva[0].image = NULL;
	}
	set_mouse_sprite(mouse_pointer);
	return 0;
}








int init_all ()
{

	mouse_sensitivity = 20;

	bfont1 = load_bitmap("data/gfx/font/font1.bmp", pal);
	bfont2 = load_bitmap("data/gfx/font/font2.bmp", pal);
	bstar1 = load_bitmap("data/gfx/level/star.bmp", pal);
	bhole[0] = load_bitmap("data/gfx/level/dira01.bmp", pal);
	bhole[1] = load_bitmap("data/gfx/level/dira02.bmp", pal);
	bhole[2] = load_bitmap("data/gfx/level/dira03.bmp", pal);
	bhole[3] = load_bitmap("data/gfx/level/dira04.bmp", pal);
	bhead[0] = load_bitmap("data/gfx/level/hit100.bmp", pal);
	bhead[1] = load_bitmap("data/gfx/level/hit66.bmp", pal);
	bhead[2] = load_bitmap("data/gfx/level/hit33.bmp", pal);
	bmhole = load_bitmap("data/gfx/level/hole.bmp", pal);
	bbang = load_bitmap("data/gfx/level/bang.bmp", pal);

	bcheat_life = load_bitmap("data/gfx/level/hit0.bmp", pal);
	bcheat_civil = load_bitmap("data/gfx/level/civil.bmp", pal);

	init_sound();

	kolt_X = 3;
	kolt_X_old = 3;
	kolt[0].X = 320 - 170;
	kolt[1].X = 320 - 115;
	kolt[2].X = 320 - 60;

	kolt[3].X = 320;

	kolt[4].X = 320 + 60;
	kolt[5].X = 320 + 115;
	kolt[6].X = 320 + 170;


	//shot_anim = load_anim_object("shot01.txt");
	nabojnik_anim = load_anim_object("naboje01.txt");
	kolt_anim = load_anim_object("kolt01.txt");


	// DVERE
	dvere[0].anim_object = load_anim_object("dvere01.txt");
	dvere[1].anim_object = load_anim_object("dvere01.txt");
	dvere[2].anim_object = load_anim_object("dvere01.txt");
	dvere[0].X = 30;
	dvere[0].Y = 83;
	dvere[1].X = 251;
	dvere[1].Y = 83;
	dvere[2].X = 473;
	dvere[2].Y = 83;


	//load_level("levels.txt", 1);


	return 0;
}






int destroy_all ()
{
	destroy_sound();

	//FIXME: znicit vsechny zvuky u vsech postav
//	destroy_sample(object[0].s_cry);
//	destroy_sample(object[0].s_dead);
//	destroy_sample(object[0].s_shot);

	//FIXME: dodelat mazani vsech objektu!
    show_mouse(NULL);
    destroy_bitmap(mouse_pointer);
	destroy_bitmap(mouse_pointer2);
	destroy_bitmap(mouse_shot);
	destroy_bitmap(bfont1);
	destroy_bitmap(bfont2);
	destroy_bitmap(bstar1);
	destroy_bitmap(bhole[0]);
	destroy_bitmap(bhole[1]);
	destroy_bitmap(bhole[2]);
	destroy_bitmap(bhole[3]);
	destroy_bitmap(bhead[0]);
	destroy_bitmap(bhead[1]);
	destroy_bitmap(bhead[2]);
	destroy_bitmap(bbang);
	destroy_bitmap(bcheat_civil);
	destroy_bitmap(bcheat_life);

	destroy_anim_object(nabojnik_anim);
	destroy_anim_object(kolt_anim);

	destroy_anim_object(dvere[0].anim_object);
	destroy_anim_object(dvere[1].anim_object);
	destroy_anim_object(dvere[2].anim_object);


#ifdef TO_VIDEO
    acquire_screen();
#endif
	destroy_bitmap(game_screen2);
    destroy_bitmap(game_screen);
#ifdef TO_VIDEO
    release_screen();
#endif
    return 0;
}
