/*----------------------------------------------------------------
 * init.h - definice hlavnich typu
 *----------------------------------------------------------------
 */

#ifndef VARIABLE_H_INCLUDED
#define VARIABLE_H_INCLUDED

#include <allegro.h>
#include <stdio.h>
#include "animator.h"

//#define DEBUG_VERSION	// kdyz je definovano, vypisuje debugovaci hlasky
//#define TO_VIDEO    // pro game_screen vytvoren ve videopameti




#define TEXTS_DIR "data/text/"
#define GFX_DIR "data/gfx/"
#define COMIX_DIR "data/comix/"
#define SOUND_DIR "data/sound/"
#define MUSIC_DIR "data/music/"
#define OBJECT_DIR "data/object/"
#define SMALL_DIR "data/small/"
#define LEVEL_DIR "data/levels/"
#define DECORATION_DIR "data/decor/"
#define TOPTEN_FILE "top.txt"

#define VRSTVA_COUNT 3
#define OBJECT_COUNT 24
#define SMALL_OBJECT_COUNT 3
#define MAX_CREATURE_COUNT 40	//maximalni pocet druhy lidi
#define DECORATION_COUNT 10
#define HOLES_TYPE_COUNT 5
#define MAX_POCET_DER 3


#define SHOT_DELAY 20
#define FIRE_SHOT_DELAY 1
#define RELOAD_DELAY 20
#define DIRA_DELAY 100

// TIMER
#define CLICK_PER_SECOND 100    // kolikrat za sekundu timer pricita
//#define ADD_PER_CLICK (0.01)    // co pricte k time_ za sekundu 
// ted bere automaticky o 1



extern PALETTE pal;
extern int color_depth;

extern BITMAP *mouse_pointer;
extern BITMAP *mouse_pointer2;
extern BITMAP *mouse_shot;
extern BITMAP *game_screen;
extern BITMAP *game_screen2;
extern BITMAP *bfont1;
extern BITMAP *bfont2;
extern BITMAP *bstar1;
extern BITMAP *bhole[HOLES_TYPE_COUNT];	// diry ve zdi (bitmapy)
extern BITMAP *bmhole;
extern BITMAP *bhead[3];	// hlava sherifa
extern BITMAP *bbang;	// bank pres obrazovku
extern BITMAP *bcheat_life;	// ikonka cheatu zivotu
extern BITMAP *bcheat_civil;	// ikonka cheatu strileni civilu




typedef struct {
    BITMAP *image;
    int X, Y, Z;
    int width, height;
} VRSTVA_STRUCTURE;

extern VRSTVA_STRUCTURE vrstva[VRSTVA_COUNT];



//typedef struct {
//	int 

typedef struct {
	int frame;
	int action;
} TICK_STRUCTURE;


typedef struct {
    ANIM_OBJECT_STRUCTURE *anim_object;		
	int max_show;	// kolikrat maximalne se muze ukazat
	int show_count;	// kolikrat uz se ukazala
	int score;
	SAMPLE *s_dead;	// zvuk smrti
	SAMPLE *s_shot;	// zvuk vystrelu
	SAMPLE *s_cry;	// zarvani (na zacatku ci komentar)
	int type;
	int delay;
	//int shot_tick;	// na ktery tick strili
	//int dead_tick;	// po tomhle ticku te strelil
	int end_tick;	// kolik celkem ticku
	int vaha;		// pravdepodobnost zvoleni
	int tick[40];	// co se deje na i-tem ticku (animace)
	int next_name;
	//int ticks_count;	// kolik ticku ma
} OBJECT_STRUCTURE;

typedef struct {
    ANIM_OBJECT_STRUCTURE *anim_object;
    int X, Y;
} DVERE_OBJECT_STRUCTURE;

typedef struct {
    //ANIM_OBJECT_STRUCTURE *anim_object;
	int draw;		// indukuje zda vubec neco obsahuje
	int type;		// typ chlapika - zda neskodny, zabijak a jaky
	int mode;		// ukazuje zda je zivy ci nikoliv
	int animation;	// ktera animace se animuje
	int position;	// pozice v animace
	int tik;		// ktery tik probida, synchronizace s dvermi
	int delay;
	long last_time;	// synchronizace s casem
	int shot_tick;	// na ktery tick strili
	int dead_tick;	// po tomhle ticku te strelil
	int end_tick;	// kolik celkem ticku
    //int draw;
    //int mode;
    int X, Y;
    //int R_X, R_Y;
    //int width, height;
} SMALL_OBJECT_STRUCTURE;

typedef struct {
    int X, Y;
} KOLT_OBJECT_STRUCTURE;

typedef struct {
    ANIM_OBJECT_STRUCTURE *anim_object;
	int type;	// jakysi 'druh' dekorace
	int mode;	// 0 - je v poradku 1 - je rozbita
    int X, Y;
	SAMPLE *s_destroy;	// zvuk zniceni
	SAMPLE *s_normal;	// zvuk opakovany
	long old_time;	//cas posledniho vystrelu
} DECORATION_STRUCTURE;



typedef struct {
	int visible;
	int X, Y;
	long old_time;
} DIRA_STRUCT;


extern DIRA_STRUCT dira[MAX_POCET_DER];



extern OBJECT_STRUCTURE object[OBJECT_COUNT];
extern SMALL_OBJECT_STRUCTURE small_object[SMALL_OBJECT_COUNT];
//extern SMALL_OBJECT_STRUCTURE creature[MAX_CREATURE_COUNT];
extern DVERE_OBJECT_STRUCTURE dvere[SMALL_OBJECT_COUNT];
extern int object_count;
extern int small_object_count;
//extern int creature_count;
extern long old_cas;
extern long spec_cas;
extern int refresh_door;	// jak casto chodi nepratele, 0 az 1000

extern int level, next_level;
//extern char *komix_start, *komix_finish;
extern char komix_start[50], komix_finish[50];

extern ANIM_OBJECT_STRUCTURE *kolt_anim;
extern ANIM_OBJECT_STRUCTURE *nabojnik_anim;
//extern ANIM_OBJECT_STRUCTURE *shot_anim;

extern int kolt_X, kolt_X_old;
extern KOLT_OBJECT_STRUCTURE kolt[7];
extern int pocet_naboju, max_pocet_naboju, celkem_naboju;
extern long shot_last_time, reload_last_time;
extern int shot_show, reload_show;	// kdyz = 1 je animace nabojniku
extern int pocet_hitu, pocet_zivotu, pocet_zabitych, score;
extern int max_doors_open;
extern int level_mode;	// 0..normalni 1..souboj 3..?
extern int level_time, max_level_bandit; // pocita cas ci pocet banditu do konce levelu
extern int max_pravdepodobnost;
extern int obtiznost;
extern DECORATION_STRUCTURE decoration[DECORATION_COUNT];
extern int decoration_count;
extern int mouse_sensitivity;

//extern int map_height, map_width;	// velikost aktualni mapy
extern int pos_X, pos_Y;               // pozice na mape


extern long cas;

#ifdef DEBUG_VERSION
extern FILE *debugfile; // debugfile
#endif


// CHEATS
extern int life_cheat;
//extern int nkotb_cheat;
extern int kill_civil_cheat;


// pro windowsi timer musi byt volatile 
//extern int btime_;    // cas dany timerem

//void inc_timer(void);   // timer

//long get_cas();
void tovy_timer();    // timer
void tovy_timer_wait();	//pro cekani
void tovy_delay(int delay);
void save_screen();



#endif // VARIABLE_H_INCLUDED



